###############################################################################
# TopicTicker.pl                                                                   #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.1                                        #
# Released:       December 2001; Updated March 22, 2002                       #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2002 Xnull (www.xnull.com) - All Rights Reserved.        #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
###############################################################################
#                           Mod-Code by AxeCrazy                              #
###############################################################################

$recentplver = "1 Gold - SP 1.1";

sub TopicTick {
	my $display = 10;
	my( @memset, @categories, %data, %cat, $numfound, $oldestfound, $curcat, %catname, %cataccess, %catboards, $openmemgr, @membergroups, %openmemgr, $curboard, @threads, @boardinfo, $i, $c, @messages, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mns, $mtime, $counter, $board, $notify );

	@categories = ();
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);

	$oldestfound = stringtotime("01/10/37 $txt{'107'} 00:00:00");

	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		$openmemgr{$curcat} = 0;
		@membergroups = split( /,/, $cataccess{$curcat} );
		foreach $tmpa (@membergroups) {
			if( $tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; }
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' ) {
			$openmemgr{$curcat} = 1;
		}
		unless( $openmemgr{$curcat} ) { next; }
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			fopen(FILE, "$boardsdir/$curboard.txt");
			@threads = <FILE>;
			fclose(FILE);

			fopen(FILE, "$boardsdir/$curboard.dat");
			@boardinfo = <FILE>;
			fclose(FILE);
			foreach (@boardinfo) {
				chomp;
			}
			@{$boardinfo{$curboard}} = @boardinfo;
			$cat{$curboard} = $curcat;

			for ($i = 0; $i < @threads; $i++) {
				chomp $threads[$i];
				($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $threads[$i] );
				fopen(FILE, "$datadir/$tnum.txt") || next;
				while( <FILE> ) { $message = $_; }
				# get only the last post for this thread.
				fclose(FILE);

				chomp $message;
				if( $message ) {
					($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$message);
					$mtime = stringtotime($mdate);
					if( $numfound >= $display && $mtime <= $oldestfound ) {
						next;
					}
					else {
						$data{$mtime} = [$curboard, $tnum, $treplies, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns, $tstate];
						if( $mtime < $oldestfound ) { $oldestfound = $mtime; }
						++$numfound;
					}
				}
			}
		}
	}
	&my_styleSheet;
		$yymain .= qq~<html><head><title>YaBB Ticker</title>$yystyle<script type="text/javascript">
posx = screen.width;function stopTicker(){clearTimeout(tick);}
function startTicker(){ticker.style.left = posx;ticker.style.visible = true;dostart();}
function dostart(){posx = posx - 1;if (posx < (-1 * ticker.offsetWidth)) posx = screen.width;ticker.style.left = posx;
tick = setTimeout("dostart();",10);}</script></head>
<body onLoad="startTicker();" style="margin: 2px"; >
<div onMouseOver="stopTicker();" onMouseOut="startTicker();" id="ticker" style="visibility: visible; position: absolute; white-space: nowrap; ;">~;

	@messages = sort {$b <=> $a } keys %data;
	if( @messages ) {
		if( @messages > $display ) { $#messages = $display - 1; }
		$counter = 1;
		# Load Censor List
		&LoadCensorList;
	}
	else {
	}
	for( $i = 0; $i < @messages; $i++ ) {
		($board, $tnum, $c, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns, $tstate) = @{ $data{$messages[$i]} };
		$displayname = $mname;
		if( $tusername ne 'Guest' ) {
			&LoadUser($tusername);
			$tname = exists $userprofile{$tusername} ? $userprofile{$tusername}->[1] : $tname;
			$tname ||= $txt{'470'};
			$tname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tusername}" alt="$txt{'27'}: $musername">$tname</a>~;
		}
		if( $musername ne 'Guest' ) {
			&LoadUser($musername);
			$mname = exists $userprofile{$musername} ? $userprofile{$musername}->[1] : $mname;
			$mname ||= $txt{'470'};
			$mname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}" alt="$txt{'27'}: $musername">$mname</a>~;
		}
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$message =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}
		####
		fopen(MBCO, "$boardsdir/$board.mbo");
		@lines = <MBCO>;
		fclose(MBCO);
		($mbco_passw,$mbco_pic) = split(/\|/, $lines[0]);
		$forboardpw = "$cookiepassword$board";
		$crypass=crypt($mbco_passw,$pwseed);
		if($mbco_passw && $yyCookies{$forboardpw} ne $crypass) {
			$message = $mbco{'13'};
			$msub = $mbco{'14'};
			#$tnum = $mbco{'14'};
			}
		####
		if($enable_notification) { $notify = qq~$menusep<a href="$scripturl?board=$board;action=notify;thread=$tnum;start=$startnum">$img{'notify'}</a>~; }
		$mdate = &timeformat($mdate);
		$yymain .= qq~
<b>$counter</b> / $boardinfo{$board}->[0] / <a href="$scripturl?board=$board;action=display;num=$tnum;start=$c" target="_blank"><u>$msub</u></a> - $mdate - <i><font size=2 class="text1" color="$color{'titletext'}"><b>($treplies)</b></font></i>
</td>
~;
		++$counter;
	}
	&Locheader;
	print $yymain;
	exit;
}

sub Locheader {
	my $headers;
	if( $yyForceIIS ) { $headers = "HTTP/1.0 200 OK\n"; }
	$headers .= "Content-type: text/html\n";
	if( $yySetCookies ) { $headers .= $yySetCookies; }
	$headers .= "\n";
	print $headers;
}

sub my_styleSheet {
	fopen(TEMPLATE,"template.html") || die("$txt{'23'}: template.html");
	@yytemplate = <TEMPLATE>;
	fclose(TEMPLATE);
	$startstyle = "no";
	for(my $i = 0; $i < @yytemplate; $i++) {
	  	$curline = $yytemplate[$i];
	  	$comp = substr($curline,1,5);
	  if ($startstyle eq "no") {
	  	if ( $comp eq "style" ) {
	  	$startstyle = "yes";
	    }
	}
	  if ($startstyle eq "yes") {
	  	$comp = substr($curline,2,5);
		$yystyle .= qq~
		$curline~;
	  	if ($comp eq "style" ) {
	  	$startstyle = "no";
	    }
	}
}
}
	  		
1;